<?php
/* * ********************************************************************
*  ProxmoxVPS Product developed. (27.03.19)
* *
*
*  CREATED BY MODULESGARDEN       ->       http://modulesgarden.com
*  CONTACT                        ->       contact@modulesgarden.com
*
*
* This software is furnished under a license and may be used and copied
* only  in  accordance  with  the  terms  of such  license and with the
* inclusion of the above copyright notice.  This software  or any other
* copies thereof may not be provided or otherwise made available to any
* other person.  No title to and  ownership of the  software is  hereby
* transferred.
*
*
* ******************************************************************** */

namespace ModulesGarden\Servers\ProxmoxCloudVps\App\UI\ServiceInformation\Forms;

use ModulesGarden\ProxmoxAddon\App\Services\ApiService;
use ModulesGarden\ProxmoxAddon\App\Services\Cloud\ProductService;
use ModulesGarden\Servers\ProxmoxCloudVps\App\UI\ServiceInformation\Providers\UpdateProvider;
use ModulesGarden\Servers\ProxmoxCloudVps\App\UI\Validators\HostnameValidator;
use ModulesGarden\Servers\ProxmoxCloudVps\App\UI\Validators\SshPublicKeyValidator;
use ModulesGarden\Servers\ProxmoxCloudVps\Core\UI\Interfaces\ClientArea;
use ModulesGarden\Servers\ProxmoxCloudVps\Core\UI\Widget\Forms\BaseForm;
use ModulesGarden\Servers\ProxmoxCloudVps\Core\UI\Widget\Forms\Fields\Select;
use ModulesGarden\Servers\ProxmoxCloudVps\Core\UI\Widget\Forms\Fields\Text;
use ModulesGarden\Servers\ProxmoxCloudVps\Core\UI\Widget\Forms\Fields\Textarea;
use function ModulesGarden\Servers\ProxmoxCloudVps\Core\Helper\isAdmin;

class UpdateForm extends BaseForm implements ClientArea
{
    use ProductService;
    use ApiService;

    public function initContent()
    {
        $this->initIds('updateForm');
        $this->setFormType('update');
        $this->setProvider(new UpdateProvider());
        $this->initFields();
        $this->loadDataToForm();
    }

    public function getAllowedActions()
    {
        return ['update'];
    }

    private function initFields()
    {
        $vm = \ModulesGarden\ProxmoxAddon\Core\Helper\sl('Vm')->getVm();
        //Hostname
        $field = new Text("hostname");
        $field->addValidator(new HostnameValidator());
        $this->addField($field);
        if ($this->configuration()->isLxc())
        {
            return;
        }
        //ISO
        if(isAdmin() || $this->configuration()->isPermissionIsoImage() && $vm->getCdRom()->count()){
            $field = new Select("iso");
            $field->notEmpty();
            $this->addField($field);
        }
        //boot device 1
        $field = new Select("bootOrder0");
        $field->notEmpty();
        $this->addField($field);
        //boot device 2
        $field = new Select("bootOrder1");
        $field->notEmpty();
        $this->addField($field);
        //boot device 3
        $field = new Select("bootOrder2");
        $field->notEmpty();
        $this->addField($field);
        //sshkeys for kvm only
        if($this->configuration()->isPermissionSshkeys()){
            $field = new Textarea("sshkeys");
            $field->addValidator(new SshPublicKeyValidator(false));
            $this->addField($field);
        }

    }
}